*include goptions;         *-- set goptions device=  etc;
goptions hsize=6 in vsize=6 in;
title 'Mosaics for specialized models fit externally to mosaics.sas';
 
proc iml worksize=10000 symsize=10000;
  dim = { 4 4 };
  /* Unaided distant vision data Bishop etal p. 284*/
     /*    Left eye grade */
   group  = {' (women)'};
   f = {1520   266   124    66,
         234  1512   432    78,
         117   362  1772   205,
          36    82   179   492 };
   title  = {'Unaided distant vision: Independence'} + group;
   vnames = {'Right Eye','Left Eye'};
   lnames = { 'High' '2' '3' 'Low',
              'High' '2' '3' 'Low'};
   reset storage=mosaic.mosaic;
   load module=_all_;
%*   %include '~/sasuser/mosaics/mosaicd.sas';
   %include mosaics(mosaicd);

   htext=1.5;
   plots={2};
   colors={BLUE RED};
   filltype={HLS HLS};
	*-- Independence model;
   run mosaic(dim, f, vnames, lnames, plots, title);
 
	*-- test quasi independence (ignore diagonal);
   initab = j(4,4) - i(4);
   qf = f - diag(f);
   call ipf(fit, stat, dim,qf, {1 2}, initab);
   fit = fit + diag(f);
   dev = (f - fit)/sqrt(fit);
   chisq=chisq(f,fit);
   df = 9-4;
   title={'Quasi Independence Model'} + group;
   print / title , chisq[r={GF LR}] df, fit[f=8.3], dev[f=8.3];

   run mosaicd(dim, f, vnames, lnames, dev, title);
 
   *-- Symmetry model;
   title={'Symmetry Model'} + group;
   fit = (f + f`)/2;
   dev = (f - fit)/sqrt(fit);
   print title, dev;
   chisq=chisq(f,fit);
   df = .5#nrow(f)#(nrow(f)-1);
   print / title , chisq[r={GF LR}] df, fit[f=8.3], dev[f=8.3];
   run mosaicd(dim, f, vnames, lnames, dev, title);
 
	*-- Quasi-symmetry;
   call ipf(fit, stat, dim,qf, config);
   dev = (qf - fit)/sqrt(fit);
   dev = dev[1:4,];
   dev = dev - diag(dev);   *-- Rounding error on diagonal?? ;
   df = .5#(nrow(f)-1)#(nrow(f)-2);
   chisq=ssq(dev) ;
   prob = 1 - probchi(chisq,df);
   print / 'Quasi-Symmetry' config, fit[f=8.3], dev[f=8.3],
                            chisq[r={GF LR} f=8.4] df prob;
   run mosaicd(dim, f, vnames, lnames, dev, title);
 
quit;
